#include "stdafx.h"
#pragma warning( disable : 4996 )

#include "OrbiterAPI.h"

#define BUFSIZE 16384

FILE *fLog = NULL;

void initLog(char *szFilename)
{
	fLog = fopen(szFilename, "w");
	//fLog = fopen(szFilename, "a");
}

void doLog(char *szFileIn, int iLine, char *szBufIn)
{
	char szBuf[BUFSIZE];
	strncpy(szBuf, szBufIn, BUFSIZE);

	if ( ! fLog )
		return ;

	if ( ! szBuf )
		return ;

	char szFileName[1024];
	char szFileExt[1024];
	char szFile[1024];
	_splitpath(szFileIn, NULL, NULL, szFileName, szFileExt);
	strcpy(szFile, szFileName);
	strcat(szFile, szFileExt);

	if ( strlen(szBuf) == 0 )
		strcpy(szBuf, "<empty log message>");

	/*char *p = szBuf;
	while (*p) {
		if (*p == '\r') *p = ' ';
		if (*p == '\n') *p = ' ';
		p++;
	}*/


	SYSTEMTIME st;
	GetLocalTime(&st);

	fprintf(fLog, "%d-%02d-%02d %02d:%02d:%02d.%03d Thread %04d %18s:%4d:%s\n", 
		st.wYear, st.wMonth, st.wDay, 
		st.wHour, st.wMinute, st.wSecond, st.wMilliseconds,
		GetCurrentThreadId(),
		szFile, iLine, szBuf);
	fflush(fLog);
#ifndef DONT_LOG_TO_SCREEN
	sprintf(oapiDebugString(), "%02d:%02d:%02d.%03d Thread %04d %s:%d:%s", 
		st.wHour, st.wMinute, st.wSecond, st.wMilliseconds,
		GetCurrentThreadId(),
		szFile, iLine, szBuf);
#endif
}

void closeLog(void)
{
	fclose(fLog);
}



